#!/bin/sh
####################################################################
#
# Remove options File for snmptrapd
#
# All Rights Reserved, Copyright (C) FUJITSU LIMITED 2010
# All Rights Reserved, Copyright (C) PFU LIMITED 2010
#
####################################################################

CURRENT_EXEC_PATH=`/usr/bin/dirname $0`
cd "$CURRENT_EXEC_PATH"
cd ../
INST_DIR=`/bin/pwd`

OPTDIR=$INST_DIR
VARDIR=$INST_DIR/var
ETCDIR=$INST_DIR/etc
BAKDIR=$VARDIR/tmp

SNMP_TRAPD_RC=/etc/init.d/snmptrapd
SNMP_TRAPD_CONF=snmptrapd.conf
SNMP_TRAPD_CONF_PATH_ETC=/etc/snmp
SNMP_TRAPD_CONF_PATH_USR=/usr/share/snmp

RestorePortAddr()
{
	if [ -f $1/$SNMP_TRAPD_CONF ]
	then
		cmd=`cat $1/$SNMP_TRAPD_CONF | grep snmpTrapdAddr | wc -l`
		if [ ${cmd} != 0 ]
		then
			sed s/#snmpTrapdAddr/snmpTrapdAddr/g $1/$SNMP_TRAPD_CONF > $BAKDIR/${SNMP_TRAPD_CONF}.bak
			mv $BAKDIR/${SNMP_TRAPD_CONF}.bak $1/$SNMP_TRAPD_CONF 2>&1
		fi
	fi
}

DeletePortAddr()
{
	if [ -f $1/$SNMP_TRAPD_CONF ]
	then
		cmd=`cat $1/$SNMP_TRAPD_CONF | grep MpSttr-Trap-Port | wc -l`
		if [ ${cmd} != 0 ]
		then
			sed '/MpSttr-Trap-Port/d' $1/$SNMP_TRAPD_CONF > $BAKDIR/${SNMP_TRAPD_CONF}.bak
			mv $BAKDIR/${SNMP_TRAPD_CONF}.bak $1/$SNMP_TRAPD_CONF 2>&1
		fi
	fi
}

# main

if [ ! -f ${SNMP_TRAPD_RC} -o ! -s ${SNMP_TRAPD_RC} ]
then
	exit 0
fi

if [ ! -f $SNMP_TRAPD_CONF_PATH_ETC/$SNMP_TRAPD_CONF ]
then
	exit 0
fi

cmd=`cat $SNMP_TRAPD_CONF_PATH_ETC/$SNMP_TRAPD_CONF | grep MpSttr-Trap-Port | wc -l`
if [ ${cmd} == 0 ]
then
	exit 0
fi

DeletePortAddr $SNMP_TRAPD_CONF_PATH_ETC 

RestorePortAddr $SNMP_TRAPD_CONF_PATH_ETC
RestorePortAddr $SNMP_TRAPD_CONF_PATH_USR

exit 0

